Index: /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/domwri.F90
===================================================================
--- /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/domwri.F90	(revision 6716)
+++ /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/domwri.F90	(revision 6717)
@@ -8,4 +8,5 @@
    !!   NEMO     1.0  ! 2002-08  (G. Madec)  F90 and several file
    !!            3.0  ! 2008-01  (S. Masson)  add dom_uniq 
+   !!            4.0  ! 2016-01  (G. Madec)  simplified mesh_mask.nc file
    !!----------------------------------------------------------------------
 
@@ -27,5 +28,4 @@
 
    PUBLIC   dom_wri              ! routine called by inidom.F90
-   PUBLIC   dom_wri_coordinate   ! routine called by domhgr.F90
    PUBLIC   dom_stiff            ! routine called by inidom.F90
 
@@ -33,74 +33,9 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2016)
    !! $Id$ 
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
-
-   SUBROUTINE dom_wri_coordinate
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE dom_wri_coordinate  ***
-      !!                   
-      !! ** Purpose :   Create the NetCDF file which contains all the
-      !!              standard coordinate information plus the surface,
-      !!              e1e2u and e1e2v. By doing so, those surface will
-      !!              not be changed by the reduction of e1u or e2v scale 
-      !!              factors in some straits. 
-      !!                 NB: call just after the read of standard coordinate
-      !!              and the reduction of scale factors in some straits
-      !!
-      !! ** output file :   coordinate_e1e2u_v.nc
-      !!----------------------------------------------------------------------
-      INTEGER           ::   inum0    ! temprary units for 'coordinate_e1e2u_v.nc' file
-      CHARACTER(len=21) ::   clnam0   ! filename (mesh and mask informations)
-      !                                   !  workspaces
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zprt, zprw 
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zdepu, zdepv
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('dom_wri_coordinate')
-      !
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'dom_wri_coordinate : create NetCDF coordinate file'
-      IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~~~~~'
-      
-      clnam0 = 'coordinate_e1e2u_v'  ! filename (mesh and mask informations)
-      
-      !  create 'coordinate_e1e2u_v.nc' file
-      ! ============================
-      !
-      CALL iom_open( TRIM(clnam0), inum0, ldwrt = .TRUE., kiolib = jprstlib )
-      !
-      !                                                         ! horizontal mesh (inum3)
-      CALL iom_rstput( 0, 0, inum0, 'glamt', glamt, ktype = jp_r8 )     !    ! latitude
-      CALL iom_rstput( 0, 0, inum0, 'glamu', glamu, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum0, 'glamv', glamv, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum0, 'glamf', glamf, ktype = jp_r8 )
-      
-      CALL iom_rstput( 0, 0, inum0, 'gphit', gphit, ktype = jp_r8 )     !    ! longitude
-      CALL iom_rstput( 0, 0, inum0, 'gphiu', gphiu, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum0, 'gphiv', gphiv, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum0, 'gphif', gphif, ktype = jp_r8 )
-      
-      CALL iom_rstput( 0, 0, inum0, 'e1t', e1t, ktype = jp_r8 )         !    ! e1 scale factors
-      CALL iom_rstput( 0, 0, inum0, 'e1u', e1u, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum0, 'e1v', e1v, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum0, 'e1f', e1f, ktype = jp_r8 )
-      
-      CALL iom_rstput( 0, 0, inum0, 'e2t', e2t, ktype = jp_r8 )         !    ! e2 scale factors
-      CALL iom_rstput( 0, 0, inum0, 'e2u', e2u, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum0, 'e2v', e2v, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum0, 'e2f', e2f, ktype = jp_r8 )
-      
-      CALL iom_rstput( 0, 0, inum0, 'e1e2u', e1e2u, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum0, 'e1e2v', e1e2v, ktype = jp_r8 )
-
-      CALL iom_close( inum0 )
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('dom_wri_coordinate')
-      !
-   END SUBROUTINE dom_wri_coordinate
-
 
    SUBROUTINE dom_wri
@@ -132,19 +67,11 @@
       !!                                   masks, depth and vertical scale factors
       !!----------------------------------------------------------------------
-      INTEGER           ::   inum0    ! temprary units for 'mesh_mask.nc' file
-      INTEGER           ::   inum1    ! temprary units for 'mesh.nc'      file
-      INTEGER           ::   inum2    ! temprary units for 'mask.nc'      file
-      INTEGER           ::   inum3    ! temprary units for 'mesh_hgr.nc'  file
-      INTEGER           ::   inum4    ! temprary units for 'mesh_zgr.nc'  file
-      CHARACTER(len=21) ::   clnam0   ! filename (mesh and mask informations)
-      CHARACTER(len=21) ::   clnam1   ! filename (mesh informations)
-      CHARACTER(len=21) ::   clnam2   ! filename (mask informations)
-      CHARACTER(len=21) ::   clnam3   ! filename (horizontal mesh informations)
-      CHARACTER(len=21) ::   clnam4   ! filename (vertical   mesh informations)
+      INTEGER           ::   inum    ! temprary units for 'mesh_mask.nc' file
+      CHARACTER(len=21) ::   clnam   ! filename (mesh and mask informations)
       INTEGER           ::   ji, jj, jk   ! dummy loop indices
       INTEGER           ::   izco, izps, isco, icav
-      !                                   !  workspaces
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zprt, zprw 
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zdepu, zdepv
+      !                               
+      REAL(wp), POINTER, DIMENSION(:,:)   ::   zprt, zprw     ! 2D workspace
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zdepu, zdepv   ! 3D workspace
       !!----------------------------------------------------------------------
       !
@@ -158,212 +85,115 @@
       IF(lwp) WRITE(numout,*) '~~~~~~~'
       
-      clnam0 = 'mesh_mask'  ! filename (mesh and mask informations)
-      clnam1 = 'mesh'       ! filename (mesh informations)
-      clnam2 = 'mask'       ! filename (mask informations)
-      clnam3 = 'mesh_hgr'   ! filename (horizontal mesh informations)
-      clnam4 = 'mesh_zgr'   ! filename (vertical   mesh informations)
-      
-      SELECT CASE ( MOD(nn_msh, 3) )
-         !                                  ! ============================
-      CASE ( 1 )                            !  create 'mesh_mask.nc' file
-         !                                  ! ============================
-         CALL iom_open( TRIM(clnam0), inum0, ldwrt = .TRUE., kiolib = jprstlib )
-         inum2 = inum0                                            ! put all the informations
-         inum3 = inum0                                            ! in unit inum0
-         inum4 = inum0
-         
-         !                                  ! ============================
-      CASE ( 2 )                            !  create 'mesh.nc' and 
-         !                                  !         'mask.nc' files
-         !                                  ! ============================
-         CALL iom_open( TRIM(clnam1), inum1, ldwrt = .TRUE., kiolib = jprstlib )
-         CALL iom_open( TRIM(clnam2), inum2, ldwrt = .TRUE., kiolib = jprstlib )
-         inum3 = inum1                                            ! put mesh informations 
-         inum4 = inum1                                            ! in unit inum1 
-         !                                  ! ============================
-      CASE ( 0 )                            !  create 'mesh_hgr.nc'
-         !                                  !         'mesh_zgr.nc' and
-         !                                  !         'mask.nc'     files
-         !                                  ! ============================
-         CALL iom_open( TRIM(clnam2), inum2, ldwrt = .TRUE., kiolib = jprstlib )
-         CALL iom_open( TRIM(clnam3), inum3, ldwrt = .TRUE., kiolib = jprstlib )
-         CALL iom_open( TRIM(clnam4), inum4, ldwrt = .TRUE., kiolib = jprstlib )
-         !
-      END SELECT
-
+      clnam = 'mesh_mask'  ! filename (mesh and mask informations)
+      
+      !                                  ! ============================
+      !                                  !  create 'mesh_mask.nc' file
+      !                                  ! ============================
+      CALL iom_open( TRIM(clnam), inum, ldwrt = .TRUE., kiolib = jprstlib )
+      !
       !                                                         ! global domain size
-      CALL iom_rstput( 0, 0, inum2, 'jpiglo', REAL( jpiglo, wp), ktype = jp_i4 )
-      CALL iom_rstput( 0, 0, inum2, 'jpjglo', REAL( jpjglo, wp), ktype = jp_i4 )
-      CALL iom_rstput( 0, 0, inum2, 'jpkglo', REAL( jpk   , wp), ktype = jp_i4 )
+      CALL iom_rstput( 0, 0, inum, 'jpiglo', REAL( jpiglo, wp), ktype = jp_i4 )
+      CALL iom_rstput( 0, 0, inum, 'jpjglo', REAL( jpjglo, wp), ktype = jp_i4 )
+      CALL iom_rstput( 0, 0, inum, 'jpkglo', REAL( jpkglo, wp), ktype = jp_i4 )
 
       !                                                         ! domain characteristics
-      CALL iom_rstput( 0, 0, inum2, 'jperio', REAL( jperio, wp), ktype = jp_i4 )
+      CALL iom_rstput( 0, 0, inum, 'jperio', REAL( jperio, wp), ktype = jp_i4 )
       !                                                         ! type of vertical coordinate
       IF( ln_zco    ) THEN   ;   izco = 1   ;   ELSE   ;   izco = 0   ;   ENDIF
       IF( ln_zps    ) THEN   ;   izps = 1   ;   ELSE   ;   izps = 0   ;   ENDIF
       IF( ln_sco    ) THEN   ;   isco = 1   ;   ELSE   ;   isco = 0   ;   ENDIF
-      CALL iom_rstput( 0, 0, inum2, 'ln_zco'   , REAL( izco, wp), ktype = jp_i4 )
-      CALL iom_rstput( 0, 0, inum2, 'ln_zps'   , REAL( izps, wp), ktype = jp_i4 )
-      CALL iom_rstput( 0, 0, inum2, 'ln_sco'   , REAL( isco, wp), ktype = jp_i4 )
+      CALL iom_rstput( 0, 0, inum, 'ln_zco'   , REAL( izco, wp), ktype = jp_i4 )
+      CALL iom_rstput( 0, 0, inum, 'ln_zps'   , REAL( izps, wp), ktype = jp_i4 )
+      CALL iom_rstput( 0, 0, inum, 'ln_sco'   , REAL( isco, wp), ktype = jp_i4 )
       !                                                         ! ocean cavities under iceshelves
       IF( ln_isfcav ) THEN   ;   icav = 1   ;   ELSE   ;   icav = 0   ;   ENDIF
-      CALL iom_rstput( 0, 0, inum2, 'ln_isfcav', REAL( icav, wp), ktype = jp_i4 )
+      CALL iom_rstput( 0, 0, inum, 'ln_isfcav', REAL( icav, wp), ktype = jp_i4 )
   
-      !                                                         ! masks (inum2) 
-      CALL iom_rstput( 0, 0, inum2, 'tmask', tmask, ktype = jp_i1 )     !    ! land-sea mask
-      CALL iom_rstput( 0, 0, inum2, 'umask', umask, ktype = jp_i1 )
-      CALL iom_rstput( 0, 0, inum2, 'vmask', vmask, ktype = jp_i1 )
-      CALL iom_rstput( 0, 0, inum2, 'fmask', fmask, ktype = jp_i1 )
+      !                                                         ! masks
+      CALL iom_rstput( 0, 0, inum, 'tmask', tmask, ktype = jp_i1 )     !    ! land-sea mask
+      CALL iom_rstput( 0, 0, inum, 'umask', umask, ktype = jp_i1 )
+      CALL iom_rstput( 0, 0, inum, 'vmask', vmask, ktype = jp_i1 )
+      CALL iom_rstput( 0, 0, inum, 'fmask', fmask, ktype = jp_i1 )
       
       CALL dom_uniq( zprw, 'T' )
       DO jj = 1, jpj
          DO ji = 1, jpi
-            jk=mikt(ji,jj) 
-            zprt(ji,jj) = tmask(ji,jj,jk) * zprw(ji,jj)                        !    ! unique point mask
+            zprt(ji,jj) = ssmask(ji,jj) * zprw(ji,jj)                        !    ! unique point mask
          END DO
       END DO                             !    ! unique point mask
-      CALL iom_rstput( 0, 0, inum2, 'tmaskutil', zprt, ktype = jp_i1 )  
+      CALL iom_rstput( 0, 0, inum, 'tmaskutil', zprt, ktype = jp_i1 )  
       CALL dom_uniq( zprw, 'U' )
       DO jj = 1, jpj
          DO ji = 1, jpi
-            jk=miku(ji,jj) 
-            zprt(ji,jj) = umask(ji,jj,jk) * zprw(ji,jj)                        !    ! unique point mask
+            zprt(ji,jj) = ssumask(ji,jj) * zprw(ji,jj)                        !    ! unique point mask
          END DO
       END DO
-      CALL iom_rstput( 0, 0, inum2, 'umaskutil', zprt, ktype = jp_i1 )  
+      CALL iom_rstput( 0, 0, inum, 'umaskutil', zprt, ktype = jp_i1 )  
       CALL dom_uniq( zprw, 'V' )
       DO jj = 1, jpj
          DO ji = 1, jpi
-            jk=mikv(ji,jj) 
-            zprt(ji,jj) = vmask(ji,jj,jk) * zprw(ji,jj)                        !    ! unique point mask
+            zprt(ji,jj) = ssvmask(ji,jj) * zprw(ji,jj)                        !    ! unique point mask
          END DO
       END DO
-      CALL iom_rstput( 0, 0, inum2, 'vmaskutil', zprt, ktype = jp_i1 )  
-      CALL dom_uniq( zprw, 'F' )
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            jk=mikf(ji,jj) 
-            zprt(ji,jj) = fmask(ji,jj,jk) * zprw(ji,jj)                        !    ! unique point mask
-         END DO
-      END DO
-      CALL iom_rstput( 0, 0, inum2, 'fmaskutil', zprt, ktype = jp_i1 )  
+      CALL iom_rstput( 0, 0, inum, 'vmaskutil', zprt, ktype = jp_i1 )  
+!!gm  ssfmask has been removed  ==>> find another solution to defined fmaskutil
+!!    Here we just remove the output of fmaskutil.
+!      CALL dom_uniq( zprw, 'F' )
+!      DO jj = 1, jpj
+!         DO ji = 1, jpi
+!            zprt(ji,jj) = ssfmask(ji,jj) * zprw(ji,jj)                        !    ! unique point mask
+!         END DO
+!      END DO
+!      CALL iom_rstput( 0, 0, inum, 'fmaskutil', zprt, ktype = jp_i1 )  
+!!gm
 
       !                                                         ! horizontal mesh (inum3)
-      CALL iom_rstput( 0, 0, inum3, 'glamt', glamt, ktype = jp_r8 )     !    ! latitude
-      CALL iom_rstput( 0, 0, inum3, 'glamu', glamu, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum3, 'glamv', glamv, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum3, 'glamf', glamf, ktype = jp_r8 )
-      
-      CALL iom_rstput( 0, 0, inum3, 'gphit', gphit, ktype = jp_r8 )     !    ! longitude
-      CALL iom_rstput( 0, 0, inum3, 'gphiu', gphiu, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum3, 'gphiv', gphiv, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum3, 'gphif', gphif, ktype = jp_r8 )
-      
-      CALL iom_rstput( 0, 0, inum3, 'e1t', e1t, ktype = jp_r8 )         !    ! e1 scale factors
-      CALL iom_rstput( 0, 0, inum3, 'e1u', e1u, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum3, 'e1v', e1v, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum3, 'e1f', e1f, ktype = jp_r8 )
-      
-      CALL iom_rstput( 0, 0, inum3, 'e2t', e2t, ktype = jp_r8 )         !    ! e2 scale factors
-      CALL iom_rstput( 0, 0, inum3, 'e2u', e2u, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum3, 'e2v', e2v, ktype = jp_r8 )
-      CALL iom_rstput( 0, 0, inum3, 'e2f', e2f, ktype = jp_r8 )
-      
-      CALL iom_rstput( 0, 0, inum3, 'ff_f', ff_f, ktype = jp_r8 )           !    ! coriolis factor
-      CALL iom_rstput( 0, 0, inum3, 'ff_t', ff_t, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum, 'glamt', glamt, ktype = jp_r8 )     !    ! latitude
+      CALL iom_rstput( 0, 0, inum, 'glamu', glamu, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum, 'glamv', glamv, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum, 'glamf', glamf, ktype = jp_r8 )
+      
+      CALL iom_rstput( 0, 0, inum, 'gphit', gphit, ktype = jp_r8 )     !    ! longitude
+      CALL iom_rstput( 0, 0, inum, 'gphiu', gphiu, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum, 'gphiv', gphiv, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum, 'gphif', gphif, ktype = jp_r8 )
+      
+      CALL iom_rstput( 0, 0, inum, 'e1t', e1t, ktype = jp_r8 )         !    ! e1 scale factors
+      CALL iom_rstput( 0, 0, inum, 'e1u', e1u, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum, 'e1v', e1v, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum, 'e1f', e1f, ktype = jp_r8 )
+      
+      CALL iom_rstput( 0, 0, inum, 'e2t', e2t, ktype = jp_r8 )         !    ! e2 scale factors
+      CALL iom_rstput( 0, 0, inum, 'e2u', e2u, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum, 'e2v', e2v, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum, 'e2f', e2f, ktype = jp_r8 )
+      
+      CALL iom_rstput( 0, 0, inum, 'ff_f', ff_f, ktype = jp_r8 )           !    ! coriolis factor
+      CALL iom_rstput( 0, 0, inum, 'ff_t', ff_t, ktype = jp_r8 )
       
       ! note that mbkt is set to 1 over land ==> use surface tmask
       zprt(:,:) = ssmask(:,:) * REAL( mbkt(:,:) , wp )
-      CALL iom_rstput( 0, 0, inum4, 'mbathy', zprt, ktype = jp_i4 )     !    ! nb of ocean T-points
+      CALL iom_rstput( 0, 0, inum, 'mbathy', zprt, ktype = jp_i4 )     !    ! nb of ocean T-points
       zprt(:,:) = ssmask(:,:) * REAL( mikt(:,:) , wp )
-      CALL iom_rstput( 0, 0, inum4, 'misf', zprt, ktype = jp_i4 )       !    ! nb of ocean T-points
+      CALL iom_rstput( 0, 0, inum, 'misf', zprt, ktype = jp_i4 )       !    ! nb of ocean T-points
       zprt(:,:) = ssmask(:,:) * REAL( risfdep(:,:) , wp )
-      CALL iom_rstput( 0, 0, inum4, 'isfdraft', zprt, ktype = jp_r8 )       !    ! nb of ocean T-points
+      CALL iom_rstput( 0, 0, inum, 'isfdraft', zprt, ktype = jp_r8 )       !    ! nb of ocean T-points
             
-      IF( ln_sco ) THEN                                         ! s-coordinate
-         CALL iom_rstput( 0, 0, inum4, 'e3t_0', e3t_0 )         !    ! scale factors
-         CALL iom_rstput( 0, 0, inum4, 'e3u_0', e3u_0 )
-         CALL iom_rstput( 0, 0, inum4, 'e3v_0', e3v_0 )
-         CALL iom_rstput( 0, 0, inum4, 'e3w_0', e3w_0 )
-         !
-         CALL dom_stiff( zprt )
-         CALL iom_rstput( 0, 0, inum4, 'stiffness', zprt )      !    ! Max. grid stiffness ratio
-         !
-         CALL iom_rstput( 0, 0, inum4, 'gdept_1d' , gdept_1d )  !    ! stretched system
-         CALL iom_rstput( 0, 0, inum4, 'gdepw_1d' , gdepw_1d )
-         CALL iom_rstput( 0, 0, inum4, 'gdept_0', gdept_0, ktype = jp_r8 )
-         CALL iom_rstput( 0, 0, inum4, 'gdepw_0', gdepw_0, ktype = jp_r8 )
-      ENDIF
-      
-      IF( ln_zps ) THEN                                         ! z-coordinate - partial steps
-         !
-         IF( nn_msh <= 6 ) THEN                                   !    ! 3D vertical scale factors
-            CALL iom_rstput( 0, 0, inum4, 'e3t_0', e3t_0 )         
-            CALL iom_rstput( 0, 0, inum4, 'e3u_0', e3u_0 )
-            CALL iom_rstput( 0, 0, inum4, 'e3v_0', e3v_0 )
-            CALL iom_rstput( 0, 0, inum4, 'e3w_0', e3w_0 )
-         ELSE                                                   !    ! 2D masked bottom ocean scale factors
-            DO jj = 1,jpj   
-               DO ji = 1,jpi
-                  e3tp(ji,jj) = e3t_0(ji,jj,mbkt(ji,jj)) * ssmask(ji,jj)
-                  e3wp(ji,jj) = e3w_0(ji,jj,mbkt(ji,jj)) * ssmask(ji,jj)
-               END DO
-            END DO
-            CALL iom_rstput( 0, 0, inum4, 'e3t_ps', e3tp )      
-            CALL iom_rstput( 0, 0, inum4, 'e3w_ps', e3wp )
-         END IF
-         !
-         IF( nn_msh <= 3 ) THEN                                   !    ! 3D depth
-            CALL iom_rstput( 0, 0, inum4, 'gdept_0', gdept_0, ktype = jp_r8 )
-            DO jk = 1,jpk   
-               DO jj = 1, jpjm1   
-                  DO ji = 1, fs_jpim1   ! vector opt.
-                     zdepu(ji,jj,jk) = MIN( gdept_0(ji,jj,jk) , gdept_0(ji+1,jj  ,jk) )
-                     zdepv(ji,jj,jk) = MIN( gdept_0(ji,jj,jk) , gdept_0(ji  ,jj+1,jk) )
-                  END DO
-               END DO
-            END DO
-            CALL lbc_lnk( zdepu, 'U', 1. )   ;   CALL lbc_lnk( zdepv, 'V', 1. )
-            CALL iom_rstput( 0, 0, inum4, 'gdepu', zdepu, ktype = jp_r8 )
-            CALL iom_rstput( 0, 0, inum4, 'gdepv', zdepv, ktype = jp_r8 )
-            CALL iom_rstput( 0, 0, inum4, 'gdepw_0', gdepw_0, ktype = jp_r8 )
-         ELSE                                                   !    ! 2D bottom depth
-            DO jj = 1,jpj   
-               DO ji = 1,jpi
-                  zprt(ji,jj) = gdept_0(ji,jj,mbkt(ji,jj)  ) * ssmask(ji,jj)
-                  zprw(ji,jj) = gdepw_0(ji,jj,mbkt(ji,jj)+1) * ssmask(ji,jj)
-               END DO
-            END DO
-            CALL iom_rstput( 0, 0, inum4, 'hdept', zprt, ktype = jp_r8 )
-            CALL iom_rstput( 0, 0, inum4, 'hdepw', zprw, ktype = jp_r8 )
-         ENDIF
-         !
-         CALL iom_rstput( 0, 0, inum4, 'gdept_1d', gdept_1d )   !    ! reference z-coord.
-         CALL iom_rstput( 0, 0, inum4, 'gdepw_1d', gdepw_1d )
-         CALL iom_rstput( 0, 0, inum4, 'e3t_1d'  , e3t_1d   )
-         CALL iom_rstput( 0, 0, inum4, 'e3w_1d'  , e3w_1d   )
-      ENDIF
-      
-      IF( ln_zco ) THEN
-         !                                                      ! z-coordinate - full steps
-         CALL iom_rstput( 0, 0, inum4, 'gdept_1d', gdept_1d )   !    ! depth
-         CALL iom_rstput( 0, 0, inum4, 'gdepw_1d', gdepw_1d )
-         CALL iom_rstput( 0, 0, inum4, 'e3t_1d'  , e3t_1d   )   !    ! scale factors
-         CALL iom_rstput( 0, 0, inum4, 'e3w_1d'  , e3w_1d   )
-      ENDIF
+      CALL iom_rstput( 0, 0, inum, 'e3t_0', e3t_0 )         !    ! scale factors
+      CALL iom_rstput( 0, 0, inum, 'e3u_0', e3u_0 )
+      CALL iom_rstput( 0, 0, inum, 'e3v_0', e3v_0 )
+      CALL iom_rstput( 0, 0, inum, 'e3w_0', e3w_0 )
+      !
+      CALL dom_stiff( zprt )
+      CALL iom_rstput( 0, 0, inum, 'stiffness', zprt )      !    ! Max. grid stiffness ratio
+      !
+      CALL iom_rstput( 0, 0, inum, 'gdept_1d' , gdept_1d )  !    ! stretched system
+      CALL iom_rstput( 0, 0, inum, 'gdepw_1d' , gdepw_1d )
+      CALL iom_rstput( 0, 0, inum, 'gdept_0', gdept_0, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum, 'gdepw_0', gdepw_0, ktype = jp_r8 )
+      
       !                                     ! ============================
-      !                                     !        close the files 
+      CALL iom_close( inum )                !        close the files 
       !                                     ! ============================
-      SELECT CASE ( MOD(nn_msh, 3) )
-      CASE ( 1 )                
-         CALL iom_close( inum0 )
-      CASE ( 2 )
-         CALL iom_close( inum1 )
-         CALL iom_close( inum2 )
-      CASE ( 0 )
-         CALL iom_close( inum2 )
-         CALL iom_close( inum3 )
-         CALL iom_close( inum4 )
-      END SELECT
       !
       CALL wrk_dealloc( jpi, jpj, zprt, zprw )
@@ -384,5 +214,4 @@
       !!                2) check which elements have been changed
       !!----------------------------------------------------------------------
-      !
       CHARACTER(len=1)        , INTENT(in   ) ::   cdgrd   ! 
       REAL(wp), DIMENSION(:,:), INTENT(inout) ::   puniq   ! 
Index: /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90
===================================================================
--- /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 6716)
+++ /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 6717)
@@ -24,5 +24,5 @@
    !!   dom_zgr       : read or set the ocean vertical coordinate system
    !!   zgr_read      : read the vertical domain coordinate and mask in domain_cfg file
-   !!   zgr_tb_level  : ocean top and bottom level for t-, u, and v-points with 1 as minimum value
+   !!   zgr_top_bot   : ocean top and bottom level for t-, u, and v-points with 1 as minimum value
    !!---------------------------------------------------------------------
    USE oce            ! ocean variables
@@ -73,19 +73,8 @@
       INTEGER  ::   ioptio, ibat, ios   ! local integer
       REAL(wp) ::   zrefdep             ! depth of the reference level (~10m)
-      !!
-!      NAMELIST/namzgr/ ln_zco, ln_zps, ln_sco, ln_isfcav, ln_linssh
       !!----------------------------------------------------------------------
       !
       IF( nn_timing == 1 )   CALL timing_start('dom_zgr')
       !
-!      REWIND( numnam_ref )              ! Namelist namzgr in reference namelist : Vertical coordinate
-!      READ  ( numnam_ref, namzgr, IOSTAT = ios, ERR = 901 )
-!901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzgr in reference namelist', lwp )
-!
-!      REWIND( numnam_cfg )              ! Namelist namzgr in configuration namelist : Vertical coordinate
-!      READ  ( numnam_cfg, namzgr, IOSTAT = ios, ERR = 902 )
-!902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzgr in configuration namelist', lwp )
-!      IF(lwm) WRITE ( numond, namzgr )
-
       IF(lwp) THEN                     ! Control print
          WRITE(numout,*)
@@ -110,5 +99,5 @@
       ELSE                          !==  User defined configuration  ==!
          IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) '          User defined horizontal mesh (usr_def_hgr)'
+         IF(lwp) WRITE(numout,*) '          User defined vertical mesh (usr_def_zgr)'
          !
          CALL usr_def_zgr( ln_zco  , ln_zps  , ln_sco, ln_isfcav,   & 
@@ -130,5 +119,5 @@
       IF(lwp) THEN                     ! Control print
          WRITE(numout,*)
-         WRITE(numout,*) '   Read in domain_cfg.nc or user defined type of vertical coordinate:'
+         WRITE(numout,*) '   Type of vertical coordinate (read in domain_cfg.nc or set through user defined routines) :'
          WRITE(numout,*) '      z-coordinate - full steps      ln_zco    = ', ln_zco
          WRITE(numout,*) '      z-coordinate - partial steps   ln_zps    = ', ln_zps
@@ -145,5 +134,5 @@
 
       !                                ! top/bottom ocean level indices for t-, u- and v-points (f-point also for top)
-      CALL zgr_tb_level( k_top, k_bot )      ! with a minimum value set to 1
+      CALL zgr_top_bot( k_top, k_bot )      ! with a minimum value set to 1
       
 
@@ -207,6 +196,6 @@
       IF(lwp) THEN
          WRITE(numout,*)
-         WRITE(numout,*) 'hgr_read : read the vertical coordinates in "domain_cfg.nc" file'
-         WRITE(numout,*) '~~~~~~~~      jpiglo = ', jpiglo, ' jpjglo = ', jpjglo, ' jpkglo = ', jpkglo
+         WRITE(numout,*) '   zgr_read : read the vertical coordinates in "domain_cfg.nc" file'
+         WRITE(numout,*) '   ~~~~~~~~      jpiglo = ', jpiglo, ' jpjglo = ', jpjglo, ' jpkglo = ', jpkglo
       ENDIF
       !
@@ -256,7 +245,7 @@
 
 
-   SUBROUTINE zgr_tb_level( k_top, k_bot )
-      !!----------------------------------------------------------------------
-      !!                    ***  ROUTINE zgr_tb_level  ***
+   SUBROUTINE zgr_top_bot( k_top, k_bot )
+      !!----------------------------------------------------------------------
+      !!                    ***  ROUTINE zgr_top_bot  ***
       !!
       !! ** Purpose :   defines the vertical index of ocean bottom (mbk. arrays)
@@ -282,6 +271,6 @@
       !
       IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) '    zgr_tb_level : ocean top and bottom k-index of T-, U-, V- and W-levels '
-      IF(lwp) WRITE(numout,*) '    ~~~~~~~~~~~~'
+      IF(lwp) WRITE(numout,*) '    zgr_top_bot : ocean top and bottom k-index of T-, U-, V- and W-levels '
+      IF(lwp) WRITE(numout,*) '    ~~~~~~~~~~~'
       !
       mikt(:,:) = MAX( k_top(:,:) , 1 )    ! top    ocean k-index of T-level (=1 over land)
@@ -313,5 +302,5 @@
       IF( nn_timing == 1 )  CALL timing_stop('zgr_top_level')
       !
-   END SUBROUTINE zgr_tb_level
+   END SUBROUTINE zgr_top_bot
 
    !!======================================================================
